/*
 * Plugin for REALbasic 3 that replaces RB's FolderItem class, making it faster
 *
 * It was written on Oct 13, 01 by Thomas Tempelmann.
 */

... unfinished.

Ideas: getting properties such as length, creationDate etc. is very slow
with FolderItem because each time a GetCatInfo or similar call is made.
This can be improved this in way:
- fetch all info once the obj is created
- provide a "ReadFromDisk" method to re-fetch the infos
- when modifying properties, do not set them right away
- modify the item on disk only if SaveToDisk() is called

#include <string.h>
#if TARGET_OS_WIN32
	static void inline DebugStr(unsigned char* p) {}
	#define log(x) OutputDebugString(x)
	#define PrepareCallback() 
	#define EnterCallback()
	#define ExitCallback()
#else
	#if TARGET_CPU_68K
		#include <SetupA4.h>
	#endif
	#include <MacMemory.h>
	#include "dcon.h"
	#define log(x) dprintf(x)
#endif


//-------------------------
// RB header includes here
//-------------------------

#include "TT's Plugin Support.h"
#include "rb_plugin.h"


//-----------------------
// Some type definitions
//-----------------------

	// "RBinteger" represents a RB "Integer" type:

typedef long RBinteger;

	// "RBbool..." represent a RB "Boolean" type; you need to watch the proper use in case of making 68K plugins:

typedef Boolean	RBboolVar;	// use this for Boolean variables stored in this plugin
typedef Boolean	RBboolPar;	// use this to receive Boolean parameters (both by value and by reference)
typedef long	RBboolRet;	// use this when returning a Boolean as a function result


//----------------
// plugin classes
//----------------

static REALfolderItem getCreatorSub (short vRefNum, OSType creator)
{
	FSSpec appSpec;
	return REALFolderItemFromFSSpec (&appSpec);
	return nil;
}

static REALfolderItem getCreatorFromCode (REALfolderItem self, REALstring creator)
{
	FSSpec selfSpec;
	if (REALFSSpecFromFolderItem (&selfSpec, self)) {
		OSType fc = *(OSType*)creator->CString();
	}
	return nil;
}

static REALfolderItem getCreatorFromFile (REALfolderItem self)
{
	FSSpec selfSpec;
	if (REALFSSpecFromFolderItem (&selfSpec, self)) {
		FInfo fi;
		if (FSpGetFInfo (&selfSpec, &fi) == noErr) {
		}
	}
	return nil;
}



static REALmethodDefinition folderItemClassMethods[] = {
	{ (REALproc) openWith, REALnoImplementation, "OpenWithApp(app as FolderItem, inFront as Boolean) as Boolean"},
};


static REALclassDefinition folderItemClass = {
	kCurrentREALControlVersion,
	"FastFolderItem",
	nil,
	sizeof(folderItemClassData),
	0,
	(REALproc) folderItemClassConstructor, (REALproc) folderItemClassDestructor,
	folderItemClassProperties,
	sizeof(folderItemClassProperties) / sizeof(REALproperty),
	folderItemClassMethods,
	sizeof(folderItemClassMethods) / sizeof(REALmethodDefinition),
};

// ---------------------------------
// ----- Plugin Initialization -----
// ---------------------------------

void PluginInit (void)
{
}

void PluginExit (void)
{
}

void PluginEntry (void)
{
	InitTTsPluginSupport ();
	#if TARGET_CPU_68K
		PrepareCallback ();
	#endif
	REALRegisterClass (&folderItemClass);
}
