/*
 * 68K Interface.c
 *
 * Provide access for PPC code to some 68K traps that are not available in a PPC Lib
 */
 
#include <MixedMode.h>
#include <Resources.h>
#include "68K Interface.h"

enum {
	par1 = kD0DispatchedPascalStackBased
		 | RESULT_SIZE (SIZE_CODE (sizeof (Boolean)))
		 | DISPATCHED_STACK_ROUTINE_SELECTOR_SIZE (SIZE_CODE (sizeof(short))),

	par2 = kD0DispatchedPascalStackBased
		 | DISPATCHED_STACK_ROUTINE_SELECTOR_SIZE (SIZE_CODE (sizeof(short)))
		 | STACK_ROUTINE_PARAMETER (2, SIZE_CODE (SIZE_CODE (sizeof(Boolean)))),

};

static far UniversalProcPtr theTrap;
static far Boolean inited = false;

void Init68KInterface ();


EXTERN_API (Boolean) SBIsControlStripVisible (void)
// moveq #0,d0; dc.w 0xAAF2
{
	if (!inited) Init68KInterface ();
	return CallUniversalProc (theTrap, par1, (short)0x0000);
}

EXTERN_API (void) SBShowHideControlStrip (Boolean showIt)
// move #$0101,d0; dc.w 0xAAF2
{
	if (!inited) Init68KInterface ();
	CallUniversalProc (theTrap, par2, (short)0x0101, (Boolean)showIt);
}


void Init68KInterface ()
{
	theTrap = GetToolTrapAddress (0xAAF2);
	inited = true;
}

// EOF
