/*
 * PPC Code Resource that provides access to OS 8.5's MenusLib functions
 *
 * By Thomas Tempelmann, rb@tempel.org
 */

#include "MenusLib Stub.h"

#include <MixedMode.h>
#include <Menus.h>

// this line is required by the linker:
ProcInfoType __procinfo = MenusStubInitProcInfo;

void main (MenusLibFuncs *funcs)
{
	funcs->showMenuBar = (VoidProc)NewRoutineDescriptor ((ProcPtr)ShowMenuBar, kPascalStackBased, GetCurrentArchitecture());
	funcs->hideMenuBar = (VoidProc)NewRoutineDescriptor ((ProcPtr)HideMenuBar, kPascalStackBased, GetCurrentArchitecture());
	funcs->isMenuBarVisible = (BoolProc)NewRoutineDescriptor ((ProcPtr)IsMenuBarVisible, kPascalStackBased|RESULT_SIZE(SIZE_CODE(sizeof(Boolean))), GetCurrentArchitecture());
}

// EOF
