/*
 * This is some glue code for PBXGetVolInfo. It is necessary to call
 * that routine from CFM or PPC code in Mac OS 7.5 until 8.1, since it
 * was missing from the InterfaceLib (despite the fact that it appears in
 * the stub lib, it is not really available!).
 *
 * You need to add this file to your PPC (and CFM) targets. You will
 * then always get two link warnings like this:
 *   Link Warning : ignored 'PBXGetVolInfoSync' (descriptor) in InterfaceLib
 *   Previously defined in PBXGetVolInfo CFM/PPC Glue.cp
 * This is normal and can be ignored.
 *
 * Apple's technote "FL 07" explains this in case you want to know more.
 *
 *   While this code is not by me, the explanation above is.
 *   Thomas Tempelmann, macdev@tempel.org, 8 Nov 99.
 */

#if GENERATINGCFM
         
#include <Traps.h>
#include <FSM.h>
         
// kFSMXGetVolInfo was not introduced until Universal Interfaces 3.0.1.
         
#if UNIVERSAL_INTERFACES_VERSION < 0x0301
    enum {
        kFSMXGetVolInfo = 0x0012
    };
#endif
         
// Define the ProcInfoType value for the PBXGetVolInfo routines.
         
enum {
    uppXGetVolInfoProcInfo = kRegisterBased |
        RESULT_SIZE(SIZE_CODE(sizeof(OSErr))) |
        REGISTER_RESULT_LOCATION(kRegisterD0) |
        REGISTER_ROUTINE_PARAMETER(1, kRegisterD0, kFourByteCode) |
        REGISTER_ROUTINE_PARAMETER(2, kRegisterD1, kFourByteCode) |
        REGISTER_ROUTINE_PARAMETER(3, kRegisterA0, SIZE_CODE(sizeof(XVolumeParamPtr)))
};
         
// Glue for the sync routine.
         
extern pascal OSErr PBXGetVolInfoSync(XVolumeParamPtr paramBlock)
{
    return CallOSTrapUniversalProc(GetOSTrapAddress(_FSDispatch), uppXGetVolInfoProcInfo,
        kFSMXGetVolInfo,            // selector   in D0
        _FSDispatch,                // trap word  in D1
        paramBlock                  // paramBlock in A0
    );
}
         
// Glue for the async routine.
         
extern pascal OSErr PBXGetVolInfoAsync(XVolumeParamPtr paramBlock)
{
    return CallOSTrapUniversalProc(GetOSTrapAddress(_FSDispatch), uppXGetVolInfoProcInfo,
        kFSMXGetVolInfo,            // selector   in D0
        _FSDispatch | kAsyncMask,   // trap word  in D1
        paramBlock                  // paramBlock in A0
    );
}

#endif
