
#include "DConPrefix.h"

/*
Boolean IsMacOSX(void)
{
	static Boolean checked = false, isMacOSX;
	UInt32 response;
	 
	if (checked) {
		return isMacOSX;
	}else{
		checked = true;
		isMacOSX = (Gestalt(gestaltSystemVersion,
                   (SInt32 *) &response) == noErr)
                	&& (response >= 0x01000);
		return isMacOSX;
	}
}
*/
Boolean IsMacOSX(void)
{
	static Boolean checked = false, isMacOSX;
	UInt32 response;
	OSErr err;
	if (checked) {
		return isMacOSX;
	}else{
		err = Gestalt(gestaltSystemVersion, (SInt32 *) &response);
		if (err == noErr)
			checked = true;
		isMacOSX = ((err == noErr) && (response >= 0x00001000));
		return isMacOSX;
	}
}


void CopyC2P(const char* src, Str255 dst)
{
	short 	length  = 0;
	// handle case of overlapping strings
	if ( (void*)src == (void*)dst )
	{
		unsigned char*		curdst = &dst[1];
		unsigned char		thisChar;
				
		thisChar = *(const unsigned char*)src++;
		while ( thisChar != '\0' ) 
		{
			unsigned char	nextChar;
			
			// use nextChar so we don't overwrite what we are about to read
			nextChar = *(const unsigned char*)src++;
			*curdst++ = thisChar;
			thisChar = nextChar;
			
			if ( ++length >= 255 )
				break;
		}
	}
	else if ( src != NULL )
	{
		unsigned char*		curdst = &dst[1];
		short 				overflow = 255;		// count down so test it loop is faster
		register char		temp;
	
		// Can't do the K&R C thing of while (*s++ = *t++) because it will copy trailing zero
		// which might overrun pascal buffer.  Instead we use a temp variable.
		while ( (temp = *src++) != 0 ) 
		{
			*(char*)curdst++ = temp;
				
			if ( --overflow <= 0 )
				break;
		}
		length = 255 - overflow;
	}
	dst[0] = length;
}

void dlog(char *format, ...)
{
	va_list args;
	char    buffer[255];

	va_start(args,format);

	strcpy(buffer + vsprintf(buffer,format,args), "");
	Str255 dst;
	CopyC2P(buffer, dst);
	
	#ifndef WIN32
		DebugStr(dst);
	#else
		OutputDebugString(buffer);
	#endif
	va_end(args);
}

#ifdef WIN32
void dprintf(char *format, ...)
{
	  va_list args;
	  char    buffer[0x80000];

	  va_start(args,format);

	  strcpy(buffer + vsprintf(buffer,format,args), "");

	  OutputDebugString(buffer);
	  va_end(args);
}

void dprintmem(const void *data, size_t length)
{
	short len = (short)(length);
	char buff[255];	
	char dummy[255]; memset( (char *)dummy, '\0', 255);
	short count = 1;
	Boolean newline = true;
	Ptr MemoryBlock = (Ptr)data;
	
	if (MemoryBlock) {		
		if (length > *(long*)(MemoryBlock+0x18)) {
			sprintf( buff,  "Are you sure you know what you are doing here\n");
			strcat(dummy,buff);
			sprintf( buff, "%d length of memory print request\n", length); strcat(dummy,buff);
			sprintf( buff, "%d size of memoryblock\n", *(long*)(MemoryBlock+0x18)); strcat(dummy,buff);
			return;
		}
		
		sprintf (buff, "Displaying %d bytes from ", length);
		strcpy (dummy, buff);
		sprintf (buff, "%08x\n", MemoryBlock); strcat (dummy, buff);
		sprintf (buff, "%08X  ", MemoryBlock); strcat (dummy, buff);


		do {
			sprintf (buff, "%02x",(QT::Byte) *MemoryBlock++); 
			strcat(dummy, buff);
						
			if (count ==  2 ) {
				sprintf (buff," ");
				strcat (dummy, buff);
			}
			if (count ==  4 ) {
				sprintf (buff," ");
				strcat (dummy, buff);
			}
			if (count ==  6 ) {
				sprintf (buff," ");
				strcat (dummy, buff);
			}
			if (count == 8) {
				sprintf (buff,"  ");
				strcat (dummy, buff);
				count = 0;
				newline = !newline;
				if ( newline && len != 1) {
					sprintf (buff,"  \n%08X  ", MemoryBlock);
					strcat (dummy, buff);
				} 
				else if (len == 1) {
					sprintf (buff,"  \n ");
					strcat (dummy, buff);
				}
					
			}
			count += 1;
		} while (--len); 		
	} 
	dprintf(dummy);
}
#endif

void dlogmem(const void *data, size_t length)
{
	short len = (short)(length);
	char buff[255];	
	char dummy[255]; memset( (char *)dummy, '\0', 255);
	short count = 1;
	Boolean newline = true;
	Ptr MemoryBlock = (Ptr)data;
	
	if (MemoryBlock) {		
		if (length > *(long*)(MemoryBlock+0x18)) {
			sprintf( buff,  "Are you sure you know what you are doing here\n");
			strcat(dummy,buff);
			sprintf( buff, "%d length of memory print request\n", length); strcat(dummy,buff);
			sprintf( buff, "%d size of memoryblock\n", *(long*)(MemoryBlock+0x18)); strcat(dummy,buff);
			return;
		}
		
		sprintf (buff, "Displaying %d bytes from ", length);
		strcpy (dummy, buff);
		sprintf (buff, "%08x\n", MemoryBlock); strcat (dummy, buff);
		sprintf (buff, "%08X  ", MemoryBlock); strcat (dummy, buff);


		do {
			sprintf (buff, "%02x",(Byte) *MemoryBlock++); 
			strcat(dummy, buff);
						
			if (count ==  2 ) {
				sprintf (buff," ");
				strcat (dummy, buff);
			}
			if (count ==  4 ) {
				sprintf (buff," ");
				strcat (dummy, buff);
			}
			if (count ==  6 ) {
				sprintf (buff," ");
				strcat (dummy, buff);
			}
			if (count == 8) {
				sprintf (buff,"  ");
				strcat (dummy, buff);
				count = 0;
				newline = !newline;
				if ( newline && len != 1) {
					sprintf (buff,"  \n%08X  ", MemoryBlock);
					strcat (dummy, buff);
				} 
				else if (len == 1) {
					sprintf (buff,"  \n ");
					strcat (dummy, buff);
				}
					
			}
			count += 1;
		} while (--len); 		
	} 
	dlog(dummy);
}
