
#pragma once


#include <string.h>
#include <stdio.h>
#include <stddef.h>
#define DCON 1

#ifndef WIN32
	#include "DCon.h"
#endif

#ifdef WIN32
	void dprintf(char *format, ...);
	void dprintmem(const void *data, size_t length);
#endif

Boolean IsMacOSX(void);
void CopyC2P(const char* src, Str255 dst);
void dlog(char *format, ...);
void dlogmem(const void *data, size_t length);

#if DCON
	#define DEBUGOSX(msg)	 	{long countRef; (msg != nil) ? countRef = *(long*) (void*) msg : countRef = 0; dlog(#msg " Refcount->(%x), Address->(%x)", countRef, msg); }
	#define MSGOSX(msg)			{dlog(#msg"");} 
	#define SIGNALOSX(y)		{dlog(#y " (%d)", y);}
	#define SIGNALHEXOSX(y)		{dlog(#y " (%x)", y);}
	#define BLOCKOSX(y,n)		{dlogmem(y,n);}
	#define MONGOOSX(x)			{dlog("%s",x);}
	#define POINTEROSX(msg)		{dlog(#msg " Address->(%x)", msg);}

	#define DEBUG9(msg)			{long countRef; (msg != nil) ? countRef = *(long*) (void*) msg : countRef = 0; dprintf(#msg " Refcount->(%x), Address->(%x)\n", countRef, msg);}
	#define MSG9(msg)			{dprintf(#msg"\n");} 
	#define SIGNAL9(y)			{dprintf(#y " (%d)\n", y);}
	#define SIGNALHEX9(y)		{dprintf(#y " (%x)\n", y);}
	#define BLOCK9(y,n)			{dprintmem(y,n);}
	#define MONGO9(x)			{dprintf("%s\n",x);}
	#define POINTER9(msg)		{dprintf(#msg " Address->(%x)\n", msg);}
#else
	#define DEBUGOSX(msg)	 	{;}
	#define MSGOSX(msg)			{;} 
	#define SIGNALOSX(y)		{;}
	#define SIGNALHEXOSX(y)		{;}
	#define BLOCKOSX(y,n)		{;}
	#define MONGOOSX(x)			{;}
	#define POINTEROSX(msg)		{;}

	#define DEBUG9(msg)			{;}
	#define MSG9(msg)			{;} 
	#define SIGNAL9(y)			{;}
	#define SIGNALHEX9(y)		{;}
	#define BLOCK9(y,n)			{;}
	#define MONGO9(x)			{;}
	#define POINTER9(msg)		{;}
#endif

#if TARGET_68K || TARGET_PPC || TARGET_CARBON
	#define DEBUG(msg) 		if (IsMacOSX())  DEBUGOSX(msg)  else DEBUG9(msg)
	#define MSG(msg) 		if (IsMacOSX())  MSGOSX(msg) 	else MSG9(msg)
	#define SIGNAL(y) 		if (IsMacOSX())  SIGNALOSX(y) 	else SIGNAL9(y)
	#define SIGNALHEX(y)	if (IsMacOSX())  SIGNALHEXOSX(y) else SIGNALHEX9(y)
	#define BLOCK(y,n)		if (IsMacOSX())  BLOCKOSX(y,n) 	else BLOCK9(y,n)
	#define MONGO(x)		if (IsMacOSX())  MONGOOSX(x) 	else MONGO9(x)
	#define POINTER(msg)	if (IsMacOSX())	 POINTEROSX(msg) else POINTER9(msg)
#else
	#define DEBUG(msg) 		DEBUG9(msg);
	#define MSG(msg) 		MSG9(msg);
	#define SIGNAL(y) 		SIGNAL9(y);
	#define SIGNALHEX(y)	SIGNALHEX9(y);
	#define BLOCK(y,n)		BLOCK9(y,n);
	#define MONGO(x)		MONGO9(x);
	#define POINTER(msg)	POINTER9(msg);
#endif