// TTs_WinHeader.h
//
// This file declares macros and functions needed for Win32 compilation
// of plugins using the REALbasic Plugin SDK.  This file should be
// set as the prefix file for your Windows (x86) target.  In addition,
// you'll need to add the "Win32-x86 Support" folder to the system
// access paths.
//
//  1997-2001 REAL Software Inc. -- All Rights Reserved

// Note from Thomas Tempelmann:
//   This is a copy of the "WinHeader.h" file from the Plugin
//   SDK v3.0.1a2. My changes are marked with !TT

#ifndef WINHEADER_H
#define WINHEADER_H

#include <Win32Headers.mch>

// !TT this #define had to be added in order to be able to
// use "OSErr" and other Mac-types in the plugin:
#define QT

// !TT removed the namespace directive
//namespace QT {
	#include <QTML.h>
	#include <Movies.h>
//}

typedef unsigned char Boolean;
typedef char *Ptr;

/*!TT not needed, only causing compiler errors because of duplicate declaration:
struct Rect
{
	short top, left, bottom, right;
};
struct Point
{
	short v, h;
};
*/

#ifdef nil
  #undef nil
#endif
#define nil 0

#ifndef true
	#define true 1
	#define false 0
#endif

//!TT added "unsigned":
unsigned long TickCount(void);

Boolean PtInRect(const Point &pt, Rect *rBounds);
Boolean SectRect(Rect *rect1, Rect *rect2, Rect *resultRect);
Ptr NewPtr(int len);
void DisposePtr(Ptr p);

#endif

