
//--------------------
// Your includes here
//--------------------

#include <math.h>
#include <string.h>
#include <UnicodeConverter.h>

#if TARGET_CPU_68K
	#include <SetupA4.h>
#endif
#include <MacMemory.h>

//-------------------------
// RB header includes here
//-------------------------

#include "TT's Plugin Support.h"
#include "rb_plugin.h"


//-----------------------
// Some type definitions
//-----------------------

typedef long RBinteger;

typedef Boolean	RBboolVar;	// use this for Boolean variables stored in this plugin
typedef Boolean	RBboolPar;	// use this to receive Boolean parameters (both by value and by reference)
typedef long	RBboolRet;	// use this when returning a Boolean as a function result


//---------------------------
// Provide global RB methods
//---------------------------

static REALstring ucToText (REALstring utf16Str, long enc)
{
	UnicodeMapping        iUnicodeMapping = {0x100, 0, kUnicodeUseLatestMapping};
	UnicodeToTextInfo     oUnicodeToTextInfo;
	Str255                strOut;
	
	iUnicodeMapping.otherEncoding = enc;
	
	#if TARGET_CPU_68K
	InitializeUnicodeConverter (NULL);
	#endif

	OSStatus err = CreateUnicodeToTextInfo (&iUnicodeMapping, &oUnicodeToTextInfo);

	if (not err) {
		err = ConvertFromUnicodeToPString(oUnicodeToTextInfo, utf16Str->Length(), (const UniChar*)utf16Str->CString(), strOut);
	
		(void) DisposeUnicodeToTextInfo (&oUnicodeToTextInfo);
	}

	#if TARGET_CPU_68K
	TerminateUnicodeConverter ();
	#endif
	
	if (not err) {
		return REALBuildString ((char*)&strOut[1], strOut[0]);
	}
	return NULL;
}


static REALmethodDefinition pluginMethodArray[] = {
	{ (REALproc) ucToText, REALnoImplementation, "TTsUTF16ToEncoding(utf16str as String, enc as Integer) as String" },
};


// ---------------------------------
// ----- Plugin Initialization -----
// ---------------------------------

void PluginExit (void)
{
}

void PluginEntry (void)
{
	InitTTsPluginSupport ();

	for (int i = 0; i < sizeof(pluginMethodArray) / sizeof(REALmethodDefinition); ++i) {
		REALRegisterMethod (&pluginMethodArray[i]);
	}
}
