//
// Base64 decoder
//
// Code taken from: http://www.fourmilab.ch/webtools/base64/
//
// modified for use as RB plugin on Mar 19, 2003 by Thomas Tempelmann (rb@tempel.org)
//
// Caution: this code uses globals for processing and is thus not re-entry capable.
//

#define LINELEN 72
#define MAXINLINE 256 \

#include <ctype.h> 
#include <string.h> 

#include "decoders.h"

static byte dtable[256];

static int insig (void)
{
	int c;
	while (TRUE) {
		c= inchar ();
		if (c==EOF||(c> ' ')) {
			return c;
		}
	}
}

long decodeBase64 (byte* text_ptr_out, long text_len_out)
{
	int i, outlen = 0;

	for (i= 0;i<255;i++) {
		dtable[i]= 0x80;
	}
	for (i= 'A';i<='I';i++) {
		dtable[i]= 0+(i-'A');
	}
	for (i= 'J';i<='R';i++) {
		dtable[i]= 9+(i-'J');
	}
	for (i= 'S';i<='Z';i++) {
		dtable[i]= 18+(i-'S');
	}
	for (i= 'a';i<='i';i++) {
		dtable[i]= 26+(i-'a');
	}
	for (i= 'j';i<='r';i++) {
		dtable[i]= 35+(i-'j');
	}
	for (i= 's';i<='z';i++) {
		dtable[i]= 44+(i-'s');
	}
	for (i= '0';i<='9';i++) {
		dtable[i]= 52+(i-'0');
	}
	dtable['+']= 62;
	dtable['/']= 63;
	dtable['=']= 0;

	while (TRUE) {
		byte a[4],b[4],o[3];
		for (i= 0;i<4;i++) {
			int c= insig ();
			if (c==EOF) {
				if (i> 0) {
					//fprintf (stderr,"Input file incomplete.\n");
					return -1;
				}
				return outlen;
			}
			if (dtable[c]&0x80) {
				//fprintf (stderr,"Illegal character '%c' in input file.\n",c);
				return -2;
			}
			a[i]= (byte)c;
			b[i]= (byte)dtable[c];
		}
		o[0]= (b[0]<<2)|(b[1]>>4);
		o[1]= (b[1]<<4)|(b[2]>>2);
		o[2]= (b[2]<<6)|b[3];
		i= a[2] == '=' ? 1 : (a[3] == '=' ? 2 : 3);

		// output
		outlen += i;
		if (outlen > text_len_out) {
			return -3; // output buffer too small
		}
		for (int j = 0; j < i; ++j) {
			*text_ptr_out++ = o[j];
		}

		if (i<3) {
			return outlen;
		}
	}
}
